%global momorel 2

%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%{!?ruby_sitearch: %global ruby_sitearch %(ruby -rrbconfig -e "puts RbConfig::CONFIG['sitearchdir']")}

Name:		libprelude
Version:	4.1.0
Release:	%{momorel}m%{?dist}
Summary:	The prelude library        

Group:		System Environment/Libraries 
License:	GPLv2+
URL:		http://prelude-ids.org/
Source0:        https://www.prelude-siem.org/attachments/download/831/%{name}-%{version}.tar.gz
NoSource:	0
# https://www.prelude-siem.org/issues/859
Patch0:         libprelude-4.1.0-linking.patch
# https://www.prelude-siem.org/issues/860
Patch1:         libprelude-4.1.0-ruby_vendorarchdir.patch
# https://www.prelude-siem.org/issues/862
Patch2:         libprelude-4.1.0-gnutls_priority_set_direct.patch
# https://www.prelude-siem.org/issues/863
Patch3:         libprelude-4.1.0-fsf_address.patch
# https://www.prelude-siem.org/issues/865
Patch4:         libprelude-4.1.0-fix_timegm.patch
# https://www.prelude-siem.org/issues/885
Patch5:         libprelude-4.1.0-fix_pthread_atfork.patch
# https://www.prelude-siem.org/issues/887
Patch6:         libprelude-4.1.0-fix_prelude_tests_timer.patch
# https://www.prelude-siem.org/issues/911
Patch7:         libprelude-4.1.0-fix_compatibility_gnutls_3_6.patch
Patch8:         libprelude-4.1.0-fix_gnulib_error_with_fseeko.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libgcrypt-devel >= 1.7.5
BuildRequires: gnutls-devel >= 3.6.2
BuildRequires: libtool-ltdl-devel >= 2.4
BuildRequires: python-devel >= 2.7
BuildRequires: python3-devel >= 3.6
BuildRequires: ruby-devel
BuildRequires: lua-devel
BuildRequires: swig chrpath

%description
Libprelude is a library that guarantees secure connections between
all sensors and the Prelude Manager. Libprelude provides an 
Application Programming Interface (API) for the communication with
Prelude sub-systems, it supplies the necessary functionality for
generating and emitting IDMEF events with Prelude and automates the
saving and re-transmission of data in times of temporary interruption
of one of the components of the system.

%package devel
Summary: 	Header files and libraries for libprelude development
Group:		System Environment/Libraries    
Requires: 	libprelude = %{version}-%{release}, automake, gnutls-devel

%description devel
Libraries, include files, etc you can use to develop Prelude IDS
sensors using the Prelude Library.

%package -n prelude-tools
Summary:        Command-line tools for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description -n prelude-tools
Provides a convenient interface for sending alerts to Prelude
Manager.

%package  python2
Summary:        Python 2 bindings for prelude
Requires:       %{name}%{?_isa} = %{version}-%{release}
%{?python_provide:%python_provide python2-prelude}

%description python2
Provides python 2 bindings for prelude.

%package python3
Summary:        Python 3 bindings for prelude
Requires:       %{name}%{?_isa} = %{version}-%{release}
%{?python_provide:%python_provide python3-prelude}

%description python3
Provides python 3 bindings for prelude.

%package perl
Summary:	Perl bindings for libprelude
Group:		System Environment/Libraries
BuildRequires:	perl-devel
Requires:	libprelude = %{version}-%{release}
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description perl
Perl bindings for libprelude.

%package ruby
Summary:	Ruby bindings for libprelude
Group:		System Environment/Libraries
Requires:	libprelude = %{version}-%{release}
Requires:	ruby(abi) = 2.5

%description ruby
Ruby bindings for libprelude.

%package lua
Summary:        Lua bindings for prelude
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       lua

%description lua
Provides Lua bindings for prelude generated by SWIG.

%prep
%setup -q

%patch0 -p1
#%%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
%configure	--disable-static \
    		--without-included-ltdl \
    		--enable-shared \
		--with-html-dir=%{_defaultdocdir}/%{name}-%{version}/html \
		--with-perl-installdirs=vendor \
		--with-ruby \
		--without-swig \
    		--without-included-regex \
		--enable-easy-bindings \
		--without-included-ltdl

# removing rpath
sed -i.rpath -e 's|LD_RUN_PATH=""||' bindings/Makefile.in
sed -i.rpath -e 's|^sys_lib_dlsearch_path_spec="/lib /usr/lib|sys_lib_dlsearch_path_spec="/%{_lib} %{_libdir}|' libtool

make %{?_smp_mflags} 

%install
rm -rf %{buildroot}

%make_install

chrpath -d %{buildroot}%{_libdir}/*.so.*

find %{buildroot} -name '*.la' -delete
find %{buildroot} -name 'perllocal.pod' -delete
find %{buildroot} -name '.packlist' -delete

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_bindir}/prelude-admin
%{_bindir}/prelude-adduser
%{_libdir}/*.so.*
%{_mandir}/man1/prelude-admin.1*
%{_mandir}/man1/libprelude-config.1*
%config(noreplace) %{_sysconfdir}/*
%{_localstatedir}/spool/*
%dir %{_defaultdocdir}/%{name}-%{version}/
%doc %{_defaultdocdir}/%{name}-%{version}/*

%files devel
%defattr(-,root,root)
%{_bindir}/libprelude-config
%{_libdir}/*.so
%dir %{_includedir}/libprelude/
%{_includedir}/libprelude/*
%{_datadir}/aclocal/libprelude.m4
%{_datadir}/libprelude
%{_libdir}/pkgconfig/libprelude.pc

%files python2
%{python2_sitearch}/_prelude.*so
%{python2_sitearch}/prelude-%{version}-py?.?.egg-info
%{python2_sitearch}/prelude.py
%{python2_sitearch}/prelude.pyc
%{python2_sitearch}/prelude.pyo

%files python3
%{python3_sitearch}/_prelude.*so
%{python3_sitearch}/__pycache__/prelude.cpython-??.*pyc
#%%{python3_sitearch}/__pycache__/prelude.cpython-??.*pyo
%{python3_sitearch}/prelude-%{version}-py?.?.egg-info
%{python3_sitearch}/prelude.py

%files perl
%{perl_vendorarch}/Prelude.pm
%dir %{perl_vendorarch}/auto/Prelude
# Force attrs because libprelude set it to 555
%attr(755, root, root) %{perl_vendorarch}/auto/Prelude/Prelude.so

%files ruby
%defattr(-,root,root)
%{ruby_sitearch}/Prelude.so

%files lua
%{_libdir}/lua/*/prelude.so

%changelog
* Tue Jun 26 2018 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-2m)
- rebuild against gnutls-3.6.2

* Tue Dec 26 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-1m)
- update 4.1.0

* Thu Sep 21 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (4.0.0-1m)
- update 4.0.0

* Wed Feb 01 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.0-1m)
- update 3.1.0

* Sun Jun 29 2014 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.1-4m)
- rebuild against perl-5.20.0

* Mon Feb 10 2014 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.1-3m)
- rebuild against perl-5.18.2

* Sat Aug 17 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.1-2m)
- rebuild against perl-5.18.1

* Sat Jun  1 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.1-1m)
- update to 1.0.1
- rebuild against gnutls-3.2.0

* Mon May 20 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-17m)
- rebuild against perl-5.18.0

* Sat Mar 16 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-16m)
- rebuild against perl-5.16.3

* Fri Nov  2 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-15m)
- rebuild against perl-5.16.2

* Sat Aug 11 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-14m)
- rebuild against perl-5.16.1

* Sun Jul  8 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-13m)
- rebuild against perl-5.16.0

* Wed Oct  5 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-12m)
- rebuild against perl-5.14.2

* Thu Jun 23 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-11m)
- rebuild against perl-5.14.1

* Thu May 05 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-10m)
- rebuild against perl-5.14.0-0.2.1m

* Sat Apr 30 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.0.0-9m)
- rebuild for python-2.7

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.0-8m)
- rebuild for new GCC 4.6

* Sun Feb 20 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.0-7m)
- add patch for gcc46, generated by gen46patch

* Sun Feb 20 2011 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.0.0-6m)
- fix BR ruby18-devel

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.0-5m)
- rebuild for new GCC 4.5

* Sun Sep 26 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.0-4m)
- rebuild against perl-5.12.2

* Fri Sep 24 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.0.0-3m)
- build fix with libtool-2.4

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.0-2m)
- full rebuild for mo7 release

* Fri Aug  6 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.0-1m)
- update to 1.0.0 with ruby18

* Tue May 18 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.22-7m)
- rebuild against perl-5.12.1

* Sat Apr 17 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.22-6m)
- rebuild against perl-5.12.0

* Sat Jan  2 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.22-5m)
- [SECURITY] CVE-2009-3736
- add --without-included-ltdl explicitly

* Mon Dec 28 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.22-4m)
- delete __libtoolize hack

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.22-3m)
- rebuild against gcc-4.4 and glibc-2.11

* Tue Aug 25 2009 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.22-2m)
- rebuild against perl-5.10.1

* Sun May 31 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.22-1m)
- update to 0.9.22 based on Fedora 11 (0.9.21.2-9)

* Mon May 11 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.9.17.2-6m)
- rebuild against libtool-ltdl-2.2.6-1m

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.17.2-5m)
- rebuild against rpm-4.6

* Thu Jan  1 2009 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.9.17.2-4m)
- rebuild against python-2.6.1-2m

* Tue Jul 15 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.17.2-3m)
- rebuild against gnutls-2.4.1

* Sun Jul  6 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.17.2-2m)
- change Source0 URL

* Thu May 22 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.9.17.2-1m)
- update 0.9.17.2
- Initial commit Momonga Linux

* Fri May 02 2008 Steve Grubb <sgrubb@redhat.com> 0.9.17.1-1
- New upstream version

* Thu Apr 24 2008 Steve Grubb <sgrubb@redhat.com> 0.9.17-1
- New upstream version

* Wed Feb 20 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.16.2-2
- Autorebuild for GCC 4.3

* Wed Jan 23 2008 Steve Grubb <sgrubb@redhat.com> 0.9.16.2-1
- New upstream version

* Mon Jan 14 2008 Steve Grubb <sgrubb@redhat.com> 0.9.16.1-1
- moved to new upstream version 0.9.16.1

* Tue Feb 20 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.13-1
- moved to new upstream version 0.9.13-1

* Fri Jan 05 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.12.1-1
- moved to new upstream version 0.9.12.1

* Tue Dec 30 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.12-6
- fixed x86_86 arch problem

* Tue Dec 30 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.12-5
- added ExcludeArch

* Tue Dec 29 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.12-4
- resolved permission problems
- added new docs 

* Tue Dec 25 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.12-3
- changed dir owner and preserved timestamps when building the package
- resolved rpath problems

* Fri Dec 22 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.12-2
- moved perl_sidearch into perl_vendorarch
- minor corrections in the spec file

* Fri Dec 22 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.12-1
- upgrade to latest upstream version 0.9.12
- minor corrections in the spec file

* Wed Dec 20 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.11-4
- removing smp-flag to debug perl- and python-problems
- added perl-bindings again

* Wed Dec 20 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.11-3
- disabled perl-bindings

* Mon Nov 20 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.11-2
- Some minor fixes in requirements

* Tue Oct 24 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.11-1
- New Fedora build based on release 0.9.11
